Lua_FactionActivityPanel = class("Lua_FactionActivityPanel", Lua_DisplayObject);
function Lua_FactionActivityPanel:ctor(p)
	self:superCall("ctor", p, "FactionPlayWindow_skin");
end

function Lua_FactionActivityPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 1096, 600));
	self.dragList:setListCell(Lua_FactionActivityItem, 130, 548, 2);
	self.dragList:setLocation(-67, -36, 0);

	self:onActDataUpdate();
	self:addLuaEvent("ACT_STATE_CHANGE", self, self.onActDataUpdate);
end

function Lua_FactionActivityPanel:onActDataUpdate(o)
	local arr = DataCenter.xianshiData:getActList(0);
	self.dragList:setLuaArrayData(arr, false);
end

function Lua_FactionActivityPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose()
		self.dragList = nil;
	end
	self:superCall("dispose");
end





--------------------------------------------------





Lua_FactionActivityItem = class("Lua_FactionActivityItem", Lua_ListCell);
function Lua_FactionActivityItem:ctor(p)
	self:superCall("ctor",p, "FactionActivityItem_skin");
end

function Lua_FactionActivityItem:buildShowItem()
	self:superCall("buildShowItem");

	self.goBtn:addClickFuntion(self, self.onGotoClick);
end

function Lua_FactionActivityItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.content.name = "c_"..data.id;
	self.nameTxt.text = data.name;
	if self.copyIcon == nil then
		self.copyIcon = UICreate.createUIAtlasImage(self.content, data.atlas, data.icon, -201, 0, 0, 0);
		self.copyIcon:setDepth(4);
	end
	self.copyIcon:setAltas(data.atlas, data.icon);
	self.copyIcon:resetSize();

	if DataCenter.roleData.level >= data.limit_level then
		self.timeTxt.text = data.pShowTime;

		self.stateBg:setEnable(true);
		self.stateTxt:setEnable(true);
		self.goBtn.mouseEnable = true;
	else
		self.timeTxt.text = LanUtil.formateStr(LanUtil.getValue(121102), tostring(data.limit_level));
		
		self.stateBg:setEnable(false);
		self.stateTxt:setEnable(false);
		self.goBtn.mouseEnable = false;
	end

	if data.bOpenToday == true then
		if data.activity_state == nil or data.activity_state == 0 or data.activity_state == 1 then
			self.stateTxt.text = LanUtil.getValue(121128);
		elseif data.activity_state == 2 then
			self.stateTxt.text = LanUtil.getValue(121129);
		elseif data.activity_state == 3 then
			self.stateTxt.text = LanUtil.getValue(121130);
		end
	else
		self.stateBg:setEnable(false);
		self.stateTxt:setEnable(false);
	end
	self.remarkTxt.text = data.remark;
end

function Lua_FactionActivityItem:onGotoClick(go)
	Lua_WindowUtil.openWin(self._data.fun_str);
end

function Lua_FactionActivityItem:dispose()
	self._data = nil;
	self:superCall("dispose");
end