checkRequire("Lua_PackData");
Lua_FactionDepotItems = class("Lua_FactionDepotItems", Lua_DragContainerItem);
function Lua_FactionDepotItems:ctor(p)
	self:superCall("ctor", p);
end
function Lua_FactionDepotItems:buildShowItem()
	self:superCall("buildShowItem");
	self.cells = Array();
	local cellSize = 25;
	local perWidth = 90;
	local perHeight = 90;
	for i=1,cellSize do
		local c = Lua_ToolImage.new(self.content);

		local px = (i - 1) % 5;
		local py = math.ceil(i / 5);
		c:setLocation(- 1 * perWidth * 5 / 2 + px * perWidth + perWidth / 2, perHeight / 2 + perHeight * 5 / 2  - perHeight * py, 0);
		c:setDepth(13);
		c:setCanClick(false);
		self.cells:add(c);
	end
	
end

function Lua_FactionDepotItems:updateItems(arr)
	local len = self.cells:getSize();	
	for i=1,len do
		if arr[i] ~= nil then
			local a = arr[i];
			local tvo = Lua_ToolVo.new(a.id, a.count, a.bind);
			tvo.packType = Lua_PackData.FACTION_WHARE;
			tvo.index = a.index;
			self.cells[i].data = tvo;
			self.cells[i]:showCloseSp(true, true, "REMOVE_FACTION_DEPOT_ITEM");
		else
			self.cells[i].data = nil;
			self.cells[i]:showCloseSp(false);
		end
	end
end
function Lua_FactionDepotItems:getHeight()
	return 300;
end