checkRequire("Lua_FactionDonateVo");
Lua_FactionDonateWindow = class("Lua_FactionDonateWindow", Lua_ThirdSizeWindow);
function Lua_FactionDonateWindow:ctor()
	self:superCall("ctor", true, 3500, true, LanUtil.getValue(121021));

	self.windowName = "Lua_FactionDonateWindow";
	self.skinName = "FactionDonateWindow_skin";
	self.w = 910;
	self.h = 660;
	self.isClickClose = false;
end

function Lua_FactionDonateWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.content:SetActive(false);

	self.normalDonateItem = Lua_FactionDonateItem.new(self.content, "normal_donate");
	self.normalDonateItem:setLocation(-285.5, -24.5, 0);
	
	self.middleDonateItem = Lua_FactionDonateItem.new(self.content, "middle_donate");
	self.middleDonateItem:setLocation(3.5, -24.5, 0);
	
	self.seniorDonateItem = Lua_FactionDonateItem.new(self.content, "senior_donate");
	self.seniorDonateItem:setLocation(291.5, -24.5, 0);
	
	self:addLuaEvent("FACTION_DONATE_DATA_UPDATE", self, self.onDonateDataUpdate);
	sendMsg(10100626,nil);
end

function Lua_FactionDonateWindow:onDonateDataUpdate()
	local donateList = DataCenter.factionData.myFactionInfo.donateDataList;
	for i,v in ipairs(donateList) do
		if v.obj_id == 0 then
			self.normalDonateItem:setData(v);
		elseif v.obj_id == 1 then
			self.middleDonateItem:setData(v);
		elseif v.obj_id == 2 then
			self.seniorDonateItem:setData(v);
		end
	
	end
	self.content:SetActive(true);
end





--------------------------------------------------





Lua_FactionDonateItem = class("Lua_FactionDonateItem",Lua_DisplayObject)
function Lua_FactionDonateItem:ctor(p,key)
	self.key = key;
	self.maxTimes =  getConfig({"league_const",key,"arr"})[1];
	self:superCall("ctor",p,"FactionDonateItem_skin");
end

function Lua_FactionDonateItem:buildFromSkin()
	self:superCall("buildFromSkin");

	self.donateData = Lua_FactionDonateVo.new(self.key);

	self.moneyIcon = UICreate.createUIAtlasImage(self.content,
		Lua_MoneyData.getMoneyIconAtlas(self.donateData.moneyType),
		Lua_MoneyData.getIconSpByMoneyType(self.donateData.moneyType), -50, -161, 0, 0);
	self.moneyIcon:setScale(0.8, 0.8)
	self.moneyIcon:setDepth(5)

	self.addBankrollTxt.text = tostring(self.donateData.addFactionBankroll);
	self.addMyContriTxt.text = tostring(self.donateData.addSelfContri);
	self.donateBtn.label = tostring(self.donateData.money);
	if self.key == "normal_donate" then
		self.titleTxt.text = LanUtil.getValue(121028);
		self.iconSp:setAltas("factionWindow", "ui_gangs_icon_03");
		self.moneyIcon:setLocation(-50, -161);
	elseif self.key == "middle_donate" then
		self.titleTxt.text = LanUtil.getValue(121029);
		self.iconSp:setAltas("factionWindow", "ui_gangs_icon_02");
		self.moneyIcon:setLocation(-20, -161);
	else
		self.titleTxt.text = LanUtil.getValue(121029);
		self.iconSp:setAltas("factionWindow", "ui_gangs_icon_02");
		self.moneyIcon:setLocation(-27, -161);
	end
	self.donateBtn:addClickFuntion(self,self.onDonateClick);
	self.maxBg:setEnable(false);
	self.maxTxt:setEnable(false);
end

function Lua_FactionDonateItem:setGray(val)
	self.bg:setGray(val);	
	self.iconSp:setGray(val);
	self.factionBankrollLb:setGray(val);
	self.myContriLb:setGray(val);
	self.addBankrollTxt:setGray(val);
	self.addMyContriTxt:setGray(val);
	self.donateBtn:setBtnEnable(not val);
	-- self.moneyIcon:setGray(val);
	
	self.maxBg:setEnable(val);
	self.maxTxt:setEnable(val);
	
	self.leftTimesTxt:setGray(val);
	self.leftTimesLb:setGray(val);
end

function Lua_FactionDonateItem:setData(v)
	local gray = v.obj_value >= self.maxTimes;
	local valueColor1 = gray == true and "[FFFFFF]" or "[00E125]";
	local valueColor2 = gray == true and "[FFFFFF]" or "[85A8BE]";
	self.leftTimesTxt.text = valueColor1..tostring(self.maxTimes - v.obj_value).."[-]"..valueColor2.."/"..tostring(self.maxTimes).."[-]";
	self:setGray(gray);
end

function Lua_FactionDonateItem:onDonateClick()	
	if DataCenter.moneyData:isMoneyEnough(self.donateData.moneyType, self.donateData.money, true, false) == true then
		local msg = getProtoMsg("Proto10100613");
		msg.donate_type = self.donateData.serverDonateType;
		sendMsg(10100613, msg);
	end
end