Lua_FactionListItem = class("Lua_FactionListItem",Lua_ListCell)
function Lua_FactionListItem:ctor(p)
	self:superCall("ctor", p, "FactionListItem_skin");
end
function Lua_FactionListItem:buildShowItem()
	self:superCall("buildShowItem");
	self.applyBtn:setDepth(self.depth+10);
	self.applyBtn:addClickFuntion(self,self.onApplyClick);
	self:addLuaEvent("FACTION_APPLY_LIST_UPDATE",self,self.checkBtn);
end
function Lua_FactionListItem:setData(data)
	self.data= data;--Lua_FactionListVo
	self.playerName.text = tostring( data.leagueName);
	self.powerLv.text = tostring(data.leagueForce);
	self.levelTxt.text = tostring(data.leagueLvl);
	self.lordName.text = tostring(data.leagueLeader);
	self.memberCount.text = tostring(data.currentCount).."/"..tostring(data.maxRole);
	self:checkBtn();
	
	if self.rankTxt ~= nil then
		self.rankTxt:setEnable(false);
	end
	if self.rankImg ~= nil then
		self.rankImg:setEnable(false);
	end
	if self.data.rankIndex <=3 then
		local rankSpName = "";
		if self.data.rankIndex == 1 then
			rankSpName = "ui_paihang_widget_no1";
		elseif self.data.rankIndex == 2 then
			rankSpName = "ui_paihang_widget_no2";
		elseif self.data.rankIndex == 3 then
			rankSpName = "ui_paihang_widget_no3";
		end
		if self.rankImg == nil then
			self.rankImg = UICreate.createUIAtlasImage(self.content, "leaderBoard_atlas", rankSpName, -390, 0, 46, 46);
			self.rankImg:setDepth(self.depth+10);
		end
		self.rankImg:setEnable(true);
		self.rankImg:setAltas("leaderBoard_atlas",rankSpName);
	else
		if self.rankTxt == nil then
			self.rankTxt = UICreate.createLabel(self.content,"",0,0,80,30,24);
			self.rankTxt:setDepth(self.depth+10);
			self.rankTxt.pivot =  UIWidget.Pivot.Center;
			self.rankTxt:setLocation(-390,0,0);
		end
		self.rankTxt:setEnable(true);
		self.rankTxt.text = tostring(self.data.rankIndex);
	end
end
function Lua_FactionListItem:checkBtn()
	local apply = DataCenter.factionData.applyFactionIds:indexOf(self.data.leagueIndex) ~= -1 and true or false;
	if self.data.applyFlag == 1 or apply == true then
		self.applyTxt.text = LanUtil.getValue(123734);
		self.applyTxt.colorStr = Lua_ColorDefine.transColor("A5A4A4");
		self.applyBtn:setGray(true);
		self.applyBtn.mouseEnable = false;		
	else
		self.applyTxt.text = LanUtil.getValue(123733);
		self.applyTxt.colorStr = Lua_ColorDefine.transColor("FFFCB7");
		self.applyBtn:setGray(false);
		self.applyBtn.mouseEnable = true;
	end
end
function Lua_FactionListItem:onApplyClick()
	local ids = Array();
	ids:add(self.data.leagueIndex);	
	DataCenter.factionData:sReqJoinFaction(ids);
end

function Lua_FactionListItem:onSelectionChange(val)
	self:superCall("onSelectionChange",val);
	
	if self.bg ~= nil then
		if val == true then
			self.bg:setAltas("factionWindow","ui_gangs_bg_05");
		else
			self.bg:setAltas("factionWindow","ui_gangs_bg_04");
		end
	end
	
	if val == true then
		Lua_MsgUtil.callFunc("FACTION_LIST_SELECTED_ITEM",self.data);
	end
end
