checkRequire("Lua_FactionListItem");
Lua_FactionListWindow = class("Lua_FactionListWindow",Lua_FullSizeWindow)
function Lua_FactionListWindow:ctor()
	self:superCall("ctor");
	self.windowName = "Lua_FactionListWindow";
    self.skinName = "FactionListWindow_skin"; 
end
function Lua_FactionListWindow:buildShowItem()
	self:superCall("buildShowItem"); 

	self:setShowTitle("titleName_altas_1", "bangpai");

	self.searchBtn:addClickFuntion(self,self.onSearchClick);
	self.oneKeyApplyBtn:addClickFuntion(self,self.onOneKeyApplyClick);
	self.createFactionBtn:addClickFuntion(self,self.onCreateFactionClick);
	self.contactLordBtn:addClickFuntion(self,self.onContactLordClick);
	
	self.dragList = Lua_DragList.new(self.content,1,Vector4(0,0,911,485));
	self.dragList:setLocation(-166, -18, 0);
	self.dragList:setListCell(Lua_FactionListItem, 60, 911, 1);

	self.searchInput.text = LanUtil.getValue(121003);
	self.searchInput.defaultText = LanUtil.getValue(121003);
	self.nameMaxLen = 12;
	
	self.dragContainer = Lua_DragContainer.new(self.content,1, Vector4(0,0, 280, 210));
	self.dragContainer:setLocation(468, 115, 0);
	self.dragContainer.uiPanel.depth = 3000;
	
	self.xuanyanItem = Lua_FactionListXuanYanItem.new(self.dragContainer);
    self.dragContainer:updateChildPos();
	LuaUtil.updateWindowDepth(nil);

	self.redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1","ui_common_hongdian",370,-111,0,0)
    self.redDot:setDepth(6);
    self.redDot.clickScale = false;
    self.redDot.name = "redDot"
	
	self:addLuaEvent("FACTION_SHOWLIST_UPDATE",self,self.onUpdateShowList);
	self:addLuaEvent("FACTION_LIST_SELECTED_ITEM",self,self.onSelectedItem);

	DataCenter.factionData:sFactionList();
end
function Lua_FactionListWindow:onSelectedItem(fvo)
	--Lua_FactionListVo
	self.curSelectFactionVo = fvo;
	if fvo ~= nil then
		self.xuanyanItem:setText(fvo.content);
--		self.declarationContentLabel.text = fvo.content;
		self.dragContainer:updateChildPos();
	end
end
function Lua_FactionListWindow:onUpdateShowList()
	self.dragList:setLuaArrayData(DataCenter.factionData.showFactionList,false);
end
function Lua_FactionListWindow:onSearchClick()
	local searchStr = self.searchInput.text;
	if searchStr == nil or searchStr == "" or searchStr == LanUtil.getValue(121003) then
		OperateAlert.show(LanUtil.getValue(121003));
		return;
	end
	if strlen(searchStr)>self.nameMaxLen then
		OperateAlert.show(LanUtil.getValue(121002));
		return;
	end
	Lua_MsgUtil.callFunc("S_FACTION_SEARCH_BY_NAME",searchStr);
end

function Lua_FactionListWindow:onOneKeyApplyClick()
	local flist = DataCenter.factionData.showFactionList;
	local ids = Array();
	local len  = flist:getSize();
	for i=1,len do
		if DataCenter.factionData.applyFactionIds:indexOf(flist[i].leagueIndex) == -1 then --只处理没有申请过的
			ids:add(flist[i].leagueIndex);			
		end
	end
	
	DataCenter.factionData:sReqJoinFaction(ids);
	self.redDot:setEnable(false);
	Lua_MsgUtil.callFunc("MAINICON_UPDATE_REDDOTSTATE", {iconId = 10013, state = false});
end

function Lua_FactionListWindow:onCreateFactionClick()
	Lua_WindowUtil.openWin("Lua_FactionCreateWindow");
end

function Lua_FactionListWindow:onContactLordClick()
	if self.curSelectFactionVo == nil then
		OperateAlert.show(LanUtil.getValue(121054));
		return;
	end
	if DataCenter.friendData:isMyFriend() == true then
		OperateAlert.show(LanUtil.getValue(121055));
		return;
	end
	
	DataCenter.friendData:sAddFriendRequest({role_id=self.curSelectFactionVo.leaderId});
	
end















Lua_FactionListXuanYanItem = class("Lua_FactionListXuanYanItem", Lua_DragContainerItem);
function Lua_FactionListXuanYanItem:ctor(dragContainer)
	self:superCall("ctor", dragContainer.sub);
	dragContainer:addSubContainer(self,true);
end
function Lua_FactionListXuanYanItem:buildShowItem()
	self:superCall("buildShowItem");	
	self.logTxt = UICreate.createLabel(self.content,"",0,0,269,240,24);
	self.logTxt.pivot =  UIWidget.Pivot.TopLeft;
	self.logTxt.spacingY = 10;
	self.logTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
	self.logTxt:setLocation(-134,100,0);
	self.logTxt:setDepth(5);
end

function Lua_FactionListXuanYanItem:setText(val)
	self.logTxt.text = "[85A8BE]"..val.."[-]";
end
function Lua_FactionListXuanYanItem:getHeight()
    return self.logTxt.height;
end
