checkRequire("Lua_JunXianUtil");
checkRequire("Lua_FactionDefine")
Lua_FactionMemberListItem = class("Lua_FactionMemberListItem",Lua_ListCell)
function Lua_FactionMemberListItem:ctor(p)
	self:superCall("ctor", p, "FactionMemberListItem_skin");
end

function Lua_FactionMemberListItem:setData(data)
	self.data= data;

	local colorStr = data.leftTime == 0 and "[FFFFFF]" or "[707070]";
	self.nameTxt.text = colorStr..data.roleName.."[-]";

	if data.title > 0  then
		local junxian = Lua_JunXianUtil.getJunxian(data.title);
		if junxian ~= nil then
			self.chenghaoTxt.text = colorStr..junxian.."[-]";	
		end
	else
		self.chenghaoTxt.text = "";
	end

	self.levelTxt.text = colorStr..tostring(data.roleLvl).."[-]";
	self.posTxt.text = colorStr..Lua_FactionDefine.getPositionNameByPos(data.leaguePos).."[-]";
	self.contributeTxt.text = colorStr..tostring(data.totalContri).."[-]";
	self.powerTxt.text = colorStr..tostring(data.roleForce).."[-]";
	
	-- 离线时间, 0表示在线
	local onlineStr;
	if data.leftTime == 0 then
		onlineStr = LanUtil.getValue(100747);
	else
		if DataCenter.factionData.isLeader == true or  DataCenter.factionData.isDeputyLeader == true then
			onlineStr = TimeTransform.getInstance():transSeconds14(data.leftTime)
		else
			onlineStr = LanUtil.getValue(121080);
		end
	end
	self.offlineTxt.text = colorStr..onlineStr.."[-]";
end

function Lua_FactionMemberListItem:onPlayerSoundClick()
	if self.data == nil then
		return;
	end

	if tostring(self.data.roleId) == tostring(DataCenter.roleData.roleId) then
		return;
	end

	local isLeader = DataCenter.factionData.isLeader;
	local isDeputyLeader = DataCenter.factionData.isDeputyLeader;
	local isMe = tostring(self.data.roleId) == tostring(DataCenter.roleData.roleId) and true or false;
	local menuTypes = Array();
	menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_CHECK_INFO,self.data.roleId));
	menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_REQ_JOIN_TEAM,self.data.roleId));
	menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_INVITE_TEAM,self.data.roleId));
	menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_ADD_FRIEND,self.data.roleId));
	
	-- 帮主、副帮主 才有权限操作职位
	if isLeader == true or isDeputyLeader == true then
		-- 不能对自己进行职位操作
		if isMe == false then
			local nextPos = Lua_FactionDefine.getNextLiftingPos(self.data.leaguePos);
			local prePos = Lua_FactionDefine.getNextLoweringPos(self.data.leaguePos);
			if nextPos ~= Lua_FactionDefine.FACTION_POS_LEADER then
				menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_FACTION_LIFTING_POS, {roleId = self.data.roleId, pos = nextPos}));
			end
			if self.data.leaguePos ~= Lua_FactionDefine.FACTION_POS_NORMAL then
				menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_FACTION_LOWERING_POS, {roleId = self.data.roleId, pos = prePos}));
			end
		end
	end
	
	if isLeader == true then
		menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_FACTION_TRANSFER_LEADER, {roleIndex = self.data.roleId, roleName = self.data.roleName}));
	end

	if isMe == false and (isLeader == true or isDeputyLeader == true)then
		menuTypes:add(Lua_MenuPopListData.new(Lua_MenuPopListData.BTN_FACTION_KICKOUT, {roleId = self.data.roleId, roleName = self.data.roleName}));
	end
	Lua_WindowUtil.openWin("Lua_MenuPopListWindow", WinParam.ACTION_OPEN,menuTypes);
end

function Lua_FactionMemberListItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.bgSp:setAltas("factionWindow","ui_gangs_bg_05");
	else
		self.bgSp:setAltas("factionWindow","ui_gangs_bg_04");
	end
end