checkRequire("Lua_FactionMemberListItem");
Lua_FactionMemberPanel = class("Lua_FactionMemberPanel",Lua_DisplayObject)
function Lua_FactionMemberPanel:ctor(p)
	self:superCall("ctor", p, "FactionMemberPanel_skin");
end

function Lua_FactionMemberPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.redDotId = 10502;

	self.dragList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 1107, 450));
	self.dragList:setListCell(Lua_FactionMemberListItem, 53, 1107, 1);
	self.dragList:setLocation(-58, -10, 0);

	self.exitBtn:addClickFuntion(self, self.onExitClick);
	self.rankBtn:addClickFuntion(self, self.onRankClick);
	self.applyListBtn:addClickFuntion(self, self.onApplyListClick);

	self:addLuaEvent("FACTION_FACTION_MEMBER_LIST", self, self.updateMemberList);
	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.updateRedDot);
	DataCenter.factionData:sMyFactionMemberList(1); -- 请求成员列表
end

function Lua_FactionMemberPanel:updateMemberList()
	self.dragList:setLuaArrayData(DataCenter.factionData.factionMemberList, false);
	self:checkRedDot();
end

function Lua_FactionMemberPanel:updateRedDot(val)
	if val.evenId ~= self.redDotId then
		return;
	end
	self:checkRedDot();
end

function Lua_FactionMemberPanel:checkRedDot()
	local showRed = DataCenter.redDotData:getRedDotStateByEventId(self.redDotId);
	if showRed then
		if self._redDot == nil then
			self._redDot = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 482, -266, 0, 0);
			self._redDot.name = "redDot";
			self._redDot:setDepth(10);
		end
		self._redDot:setEnable(true);
	else
		if self._redDot ~= nil then
			self._redDot:setEnable(false);
		end
	end
end

function Lua_FactionMemberPanel:onExitClick()
	local tipsStr;
	if DataCenter.factionData.myFactionInfo.leaguePos < Lua_FactionDefine.FACTION_POS_LEADER then
		tipsStr = LanUtil.getValue(121038);
	else
		tipsStr = LanUtil.getValue(121039);
	end
	Lua_WindowUtil.openWin("Lua_TipsWindow", nil, {owner = self, des = tipsStr, type = 1, subFun = self.doExit});
end

function Lua_FactionMemberPanel:doExit()
	sendMsg(10100608, nil);
end

function Lua_FactionMemberPanel:onRankClick()
	Lua_WindowUtil.openWin("Lua_FactionRankWindow")
end

function Lua_FactionMemberPanel:onApplyListClick()
	Lua_WindowUtil.openWin("Lua_FactionApplyListWindow",WinParam.ACTION_OPEN);
end

function Lua_FactionMemberPanel:dispose()
	if self.dragList ~= nil then
		self.dragList:dispose();
		self.dragList = nil;
	end

	self:superCall("dispose");
end