Lua_FactionNoticeEditWindow = class("Lua_FactionNoticeEditWindow",Lua_ThirdSizeWindow)
function Lua_FactionNoticeEditWindow:ctor()
	self:superCall("ctor",true,3500,true,LanUtil.getValue(121619));
	self.w = 600;
	self.h = 410;
	self.depth = 3500;
	self.windowName = "Lua_FactionNoticeEditWindow";
	self.skinName = "FactionNoticeEditWindow_skin";
	self.titleText = LanUtil.getValue(121058);
end
function Lua_FactionNoticeEditWindow:buildShowItem()
	self:superCall("buildShowItem");
	self.saveBtn:addClickFuntion(self,self.onSaveClick);
	self.broadcastBtn:addClickFuntion(self,self.onBroadcastClick);
	
	self.dragContainer = Lua_DragContainer.new(self.content,1, Vector4(0, 50, 550, 192));
	self.dragContainer:setLocation(0,0, 0);
--	self.dragContainer:addSubContainer(self.noticeInput,true);
	self.dragContainer.canDrag=true;
	self.txtItem = Lua_FactionNoticeEditTxtItem.new(self.dragContainer);
	self.dragContainer:updateChildPos();
	
   --[[ self.uiPanel = self.noticeInput.mainContent:AddComponent(typeof(UIPanel));
    self.uiPanel.cullWhileDragging = false;
    self.uiPanel.softBorderPadding = false;

    self.uiPanel.clipSoftness = Vector2(0, 0);
    self.uiPanel.clipOffset = Vector2(0, 0);
    self.uiPanel.anchorOffset = false;
    self.uiPanel.widgetsAreStatic = false;
    self.uiPanel.baseClipRegion = Vector4(222,-62,477,132);
    self.uiPanel.clipping = UIDrawCall.Clipping.SoftClip;--]]
	self:addTimer("checkTxtHeight",0.5,self,self.checkTxtHeight);
	local mfi = DataCenter.factionData.myFactionInfo;
	local maxTimes = getConfig({"league_const","modify_content_times","value"});
--	print("maxTimes",maxTimes,mfi.useTimes);
--	local tColor = mfi.useTimes>= maxTimes and "[ff0000]" or "[001a0f]";
	local showTimes = maxTimes - mfi.useTimes;
	self.showTimes = showTimes;
	local descStr = LanUtil.getValue(121056);
	local countStr = tostring(showTimes).."/"..tostring(maxTimes).."[-]"
	self.costMoney = getConfig({"league_const","modify_gold","value"});
	if showTimes <=0 then
		descStr = LanUtil.formateStr(LanUtil.getValue(121057), tostring(self.costMoney ));
		countStr = "";
	end
	descStr = "[85A8BE]"..descStr;
	self.freeTimesTxt.text = descStr..countStr;
end
function Lua_FactionNoticeEditWindow:checkTxtHeight()
	self.txtItem:setBoxSize();
	self.dragContainer:updateChildPos();
end
function Lua_FactionNoticeEditWindow:onSaveClick(go)
	self:sendSave(0);
end

function Lua_FactionNoticeEditWindow:onBroadcastClick(go)
	if self.showTimes<=0 then
		if DataCenter.moneyData:isMoneyEnough(Lua_MoneyData.GOLD_AND_BINDGOLD,self.costMoney,true,false) == false then
			return;
		end
	end
	self:sendSave(1);
end

function Lua_FactionNoticeEditWindow:sendSave(broadcast)
	if LanUtil.isIncludeInvalidWord(self.txtItem.contentText) == true then
		OperateAlert.show(LanUtil.getValue(121059));
		return;
	end
	local tstr = self.txtItem.contentText;
	tstr = Lua_ChatUtil.replaceChatMsg(tstr);
	local a = string.find(tstr,"%w%w%w%w%w");
	if a ~= nil then
		OperateAlert.show(LanUtil.getValue(121059));
		return;
	end
	local clen = getConfig({"league_const","content_length","value"});
	if clen <= stringWidth(tstr) then
		OperateAlert.show(LanUtil.getValue(121060));
		return;
	end
	if DataCenter.factionData.myFactionInfo.leagueIntro == tstr then
		OperateAlert.show(LanUtil.getValue(121076));
		return;
	end
	local msg = getProtoMsg("Proto10100611");
	msg.league_intro = self.txtItem.contentText;
	msg.type = broadcast;
	--DataCenter.factionData.myFactionInfo.leagueIntro =  tstr;
	sendMsg(10100611,msg);
	Lua_MsgUtil.callFunc("FACTION_MY_FACTION_INFO");
	self:hide();
end

Lua_FactionNoticeEditTxtItem = class("Lua_FactionNoticeEditTxtItem", Lua_DragContainerItem)
function Lua_FactionNoticeEditTxtItem:ctor(dragContainer)
	self:superCall("ctor", dragContainer.sub);
	dragContainer:addSubContainer(self,true);

end
function Lua_FactionNoticeEditTxtItem:buildShowItem()
	self:superCall("buildShowItem");
	self.contentTxt = UICreate.createInput(self.content,"",0,0,550,192,24);
	self.contentTxt.pivot =  UIWidget.Pivot.TopLeft;
	self.contentTxt.spacingY = 8;
	self.contentTxt:setLocation(-273,134,0);
	self.contentTxt:setDepth(5);
	self.contentTxt.text = DataCenter.factionData.myFactionInfo.leagueIntro;
	self.contentTxt.colorStr =  Lua_ColorDefine.transColor("85A8BE");
	self.contentTxt.overflowMethod = UILabel.Overflow.ResizeHeight;
--	 self.logTxt:StartInput();
end


function Lua_FactionNoticeEditTxtItem:setBoxSize()
	local th = self.contentTxt.textHeight;
	if th < 120 then
		th = 120;
	end
	self.contentTxt:SetDimensions(550,th);
	self.contentTxt:SetBoxCenter(225,-self.contentTxt.textHeight/2);
end
function Lua_FactionNoticeEditTxtItem:getHeight()
    return self.contentTxt.textHeight;
end
function Lua_FactionNoticeEditTxtItem:onPlayerSoundClick()
--  self.logTxt:StartInput();
end
function Lua_FactionNoticeEditTxtItem.Get:contentText()
	return self.contentTxt.text;
end