checkRequire("Lua_FactionSkillNormalDetail");
checkRequire("Lua_FactionSkillMaxDetail");
Lua_FactionSkillWindow = class("Lua_FactionSkillWindow", Lua_SecondSizeWindow);
function Lua_FactionSkillWindow:ctor()
	self:superCall("ctor");

	self.windowName = "Lua_FactionSkillWindow";
	self.skinName = "FactionSkillWindow_skin";
	self.titleText = LanUtil.getValue(121022);
end

function Lua_FactionSkillWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.selectedDefault = false;

	self.maxDetail = Lua_FactionSkillMaxDetail.new(self.content);
	self.maxDetail:setEnable(false);
	self.normalDetail = Lua_FactionSkillNormalDetail.new(self.content);
	
	self.dragList = Lua_DragList.new(self.content,1,Vector4(-222,-27,646,530));
	self.dragList:setLocation(0, 0, 0);
	self.dragList:setListCell(Lua_FactionSkillListItem, 113, 324, 2);
	
	self:addLuaEvent("FACTION_SKILL_LIST_UPDATE", self, self.onSkillListUpdate);
	self:addLuaEvent("FACTION_SKILL_UPGRADE", self, self.onSkillUpgrade);
	self:addLuaEvent("FACTION_SKILL_SELECT_ITEM", self, self.onSkillSelectItem);
	sendMsg(10100627);
end

function Lua_FactionSkillWindow:onSkillSelectItem(skillVo)
	self.skillVo = skillVo;

	self.lvTxt.text = "Lv."..skillVo.skillLv;
	self.skillNameTxt.text = skillVo.name;
	self.skillIcon:setAltas("skillIcon_atlas_1", skillVo.skillIcon);
	if skillVo.isMax == true then
		self.maxDetail:setEnable(true);
		self.normalDetail:setEnable(false);

		self.maxDetail:setData(skillVo);
	else
		self.maxDetail:setEnable(false);
		self.normalDetail:setEnable(true);

		self.normalDetail:setData(skillVo);
	end
end

function Lua_FactionSkillWindow:onSkillUpgrade(skillType)
	self:onSkillListUpdate();
	local arr = DataCenter.factionData.factionSkillList;
	for i = 1, arr:getSize() do
		if arr[i].skillType == skillType then
			self:onSkillSelectItem(arr[i]);
			break;
		end
	end
end

function Lua_FactionSkillWindow:onSkillListUpdate()
	self.dragList:setLuaArrayData(DataCenter.factionData.factionSkillList, false);
	if self.selectedDefault == false then
		self.dragList:setSelected(1);
		self.selectedDefault = true;
	end
end





--------------------------------------------------





Lua_FactionSkillListItem = class("Lua_FactionSkillListItem",Lua_ListCell)
function Lua_FactionSkillListItem:ctor(p)
	self:superCall("ctor", p, "FactionSkillListItem_skin");
end

function Lua_FactionSkillListItem:buildShowItem()
	self:superCall("buildShowItem");
	
	self:addLuaEvent("UPDATE_REDDOT_EVENT", self, self.updateRedDot);
end

function Lua_FactionSkillListItem:setData(data)
	self._data = data; -- Lua_FactionSkillVo
	if data == nil then
		return;
	end

	self.skillNameTxt.text = data.name;
	self.skillIcon:setAltas("skillIcon_atlas_1", data.skillIcon);
	self:checkRedDot();
end

function Lua_FactionSkillListItem:updateRedDot(val)
	if val.evenId ~= self._data.redDot then
		return;
	end
	self:checkRedDot();
end

function Lua_FactionSkillListItem:checkRedDot()
	local showRed = DataCenter.redDotData:getRedDotStateByEventId(self._data.redDot);
	if showRed == true then
		if self.redDotIcon == nil then
			self.redDotIcon = UICreate.createUIAtlasImage(self.content, "common_atlas_1", "ui_common_hongdian", 145, 50, 0, 0);
			self.redDotIcon:setDepth(self.depth + 2);
		end
		self.redDotIcon:setEnable(true);
	else
		if self.redDotIcon ~= nil then
			self.redDotIcon:setEnable(false);
		end
	end
	self:setLearn(self._data.isLearn);
end

function Lua_FactionSkillListItem:setLearn(val)
	self.lockMask:setEnable(not val);
	self.lockIcon:setEnable(not val);
	if val == true then
		self.skillLvTxt.text= "[85A8BE]Lv.".. tostring(self._data.skillLv);
	else
		self.skillLvTxt.text= LanUtil.formateStr(LanUtil.getValue(121042), tostring(self._data.skillOpenLv));
	end
end

function Lua_FactionSkillListItem:onSelectionChange(val)
	self:superCall("onSelectionChange", val);

	if val == true then
		self.bg:setAltas("common_atlas_1", "ui_common_widget_p2");
		Lua_MsgUtil.callFunc("FACTION_SKILL_SELECT_ITEM", self._data);
	else
		self.bg:setAltas("common_atlas_1", "ui_common_widget_p1");
	end
	self.xzk:setEnable(val);
end